#include <windows.h>
#include <stdio.h>
#include <commctrl.h>
#include <mbstring.h>
#include <dshow.h>
#include "resource.h"

#pragma comment(lib,"strmiids.lib")
#pragma comment(lib,"comctl32.lib")

#define MYWNDTITLE		"MediaConverter"
#define RELEASE(p)		if (p){p->Release();p=NULL;}
#define MAX_FIL			64	// 񋓂GR[_ tB^̍ő吔
#define MAX_LEN			64	// GR[_ tB^̍ő啶
#define WM_GRAPHNOTIFY	WM_USER + 1

ICaptureGraphBuilder2	*g_pCGB = NULL;
IGraphBuilder			*g_pGB	= NULL;
IMediaEventEx			*g_pME  = NULL;
IMediaControl			*g_pMC	= NULL;
IBaseFilter				*g_pSrc = NULL;	// \[X

typedef struct{
	int			idx;					// IꂽtB^̔ԍ
	int			ct;						// 񋓂ꂽtB^
	int			order[MAX_FIL];			// ёւ̏
	char		name[MAX_FIL][MAX_LEN];	// 񋓂ꂽth
	IBaseFilter	*pFil[MAX_FIL];			// 񋓂ꂽtB^ IuWFNg
}DECENC,LPDECENC;

DECENC	g_de[2];	// 0:Audio encoder, 1:Video encoder

HWND	g_hDlg     = NULL;
HWND	g_hSttc[3] = {NULL,NULL,NULL};
HWND	g_hComb[2] = {NULL,NULL};
HWND	g_hSldr    = NULL;
HWND	g_hBttn    = NULL;
char	g_loadname[MAX_PATH];	// ǂݍ݃t@C
char	g_savename[MAX_PATH];	// ۑt@C
int		g_quality = 85;			// kii0 ` 100j
int		g_PCM = 0;				// R{{bNX "PCM" ̔ԍ
bool	g_bAvi = 0;				// ϊ̌`i0:ި, 1:AVIj
int		g_ext_idx = 0;			// \zۑgqԍi0:WMA, 1:MP3, 2.WAV, 3:AVI, 4:̑j
char	g_ext_s[][8] = {".wma",".mp3",".wav",".avi",".*"};	// ۑgqXg

void	Stop();
bool	Run_Graph();
bool	Save_WavFile();
bool	Save_AviFile();
bool	Enum_FiltersEnc(HWND hDlg, REFCLSID clsid);
void	Sort(int idx);
void	Enable_AVI(bool bEnable);
void	Set_Title(char *addStr);
bool	Open_FileDlg();
void	Save_FileDlg();
void	Set_SaveType();
void	Cleanup();

int CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	UINT i,j;
	switch (uMsg)
	{
	case WM_INITDIALOG:
		if(FAILED(CoInitialize(NULL))){
			MessageBox(hDlg,"COM ̏Ɏs܂",MYWNDTITLE,MB_OK);
			SendMessage(hDlg,WM_CLOSE,0,0);
			return 0;
		}
		InitCommonControls();
		g_hSttc[0] = GetDlgItem(hDlg, IDC_STATIC1);
		g_hSttc[1] = GetDlgItem(hDlg, IDC_STATIC2);
		g_hSttc[2] = GetDlgItem(hDlg, IDC_STATIC3);
		g_hComb[0] = GetDlgItem(hDlg, IDC_COMBO1);
		g_hComb[1] = GetDlgItem(hDlg, IDC_COMBO2);
		g_hSldr    = GetDlgItem(hDlg, IDC_SLIDER1);
		g_hBttn    = GetDlgItem(hDlg, IDC_RUN);
		SendMessage(g_hSldr, TBM_SETTICFREQ, 50, 0);
		SendMessage(g_hSldr, TBM_SETRANGE, TRUE, MAKELONG(0,100));
		SendMessage(g_hSldr, TBM_SETPOS, TRUE, g_quality);
		Enable_AVI(FALSE);
		g_bAvi = 0;
		SendDlgItemMessage(hDlg, IDC_RADIO1, BM_SETCHECK, BST_CHECKED, 0);
		// I[fBI GR[_̗
		if(!Enum_FiltersEnc(hDlg, CLSID_AudioCompressorCategory)){
			MessageBox(hDlg,"I[fBI GR[_񋓂ł܂",MYWNDTITLE,MB_OK);
			SendMessage(hDlg,WM_CLOSE,0,0);
			return 0;
		}
		// rfI GR[_̗
		if(!Enum_FiltersEnc(hDlg, CLSID_VideoCompressorCategory)){
			MessageBox(hDlg,"rfI GR[_񋓂ł܂",MYWNDTITLE,MB_OK);
			SendMessage(hDlg,WM_CLOSE,0,0);
			return 0;
		}
		for(i=0;i<2;i++){
			Sort(i);
			SendMessage(g_hComb[i], CB_SETCURSEL, g_de[i].idx, 0);
		}
		break;

	case WM_SHOWWINDOW:
		if(__argc > 1){
			strcpy(g_loadname, __argv[1]);
			Set_Title("");
			__argc = 0;
		}
		break;

	case WM_DROPFILES:
		HDROP	hDrop;
		hDrop = (HDROP) wParam;
		DragQueryFile(hDrop, 0, g_loadname, sizeof(g_loadname));
		DragFinish(hDrop);
		Set_Title("");
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDM_OPEN:
			if(Open_FileDlg()){
				Set_Title("");
			}
			break;
		
		case IDM_EXIT:
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;
		
		case IDC_RUN:	// s
			if(!strcmp(g_loadname, "")){
				MessageBox(hDlg,"t@C܂",MYWNDTITLE,MB_ICONINFORMATION);
				break;
			}
			g_de[0].idx = SendMessage(g_hComb[0], CB_GETCURSEL, 0, 0);
			g_de[1].idx = SendMessage(g_hComb[1], CB_GETCURSEL, 0, 0);
			if(g_de[0].idx >= 0 && g_de[1].idx >= 0){
				Save_FileDlg();
			}
			break;
		
		case IDC_EXIT:	// I
			SendMessage(hDlg,WM_CLOSE,0,0);
			break;
		
		case IDC_RADIO1:// I[fBI
			g_bAvi = 0;
			Enable_AVI(FALSE);
			break;
		
		case IDC_RADIO2:// rfI
			g_bAvi = 1;
			Enable_AVI(TRUE);
			SendMessage(g_hComb[0], CB_SETCURSEL, g_PCM, 0);
			break;
		
		default:
			return FALSE;
		}
		break;

	case WM_GRAPHNOTIFY:
		long evCode, param1, param2;
		if(!g_pME)	break;
		while(SUCCEEDED(g_pME->GetEvent(&evCode, &param1, &param2, 0)))
		{
			g_pME->FreeEventParams(evCode, param1, param2);
			if(evCode == EC_COMPLETE){
				Stop();
				break;
			}
		}
		break;

	case WM_CLOSE:
		for(i=0;i<2;i++){
			for(j=0;j<MAX_FIL;j++){
				RELEASE(g_de[i].pFil[j]);
			}
		}
		DestroyWindow(hDlg);
		Cleanup();
		CoUninitialize();
		PostQuitMessage(0);
		break;

	default:
		return FALSE;
	}
	return TRUE;
}// DlgProc

int APIENTRY WinMain(HINSTANCE hInst, HINSTANCE hInstPrev, LPSTR lpCmdLine, int nCmdShow)
{
	g_hDlg = CreateDialog(hInst, MAKEINTRESOURCE(IDD_DIALOG1), NULL, DlgProc);
	ShowWindow(g_hDlg, nCmdShow);
	
	MSG		msg;
	while(GetMessage(&msg, NULL, 0, 0)) {
		if (IsDialogMessage(g_hDlg, &msg)) continue;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

void Stop()
{
	Cleanup();
	SetCursor(NULL);
	ReleaseCapture();
	Set_Title("");
}// Stop

// tB^Ot쐬EsEۑ
bool Run_Graph()
{
	HRESULT hr;
	
	Cleanup();
	EnableWindow(g_hBttn, FALSE);
	
	RELEASE(g_pGB);
	hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER,
						  IID_IGraphBuilder, (void **)&g_pGB);
	if(FAILED(hr)){
		MessageBox(g_hDlg,"1",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	RELEASE(g_pCGB);
	hr = CoCreateInstance(CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC_SERVER, 
						  IID_ICaptureGraphBuilder2, (void **)&g_pCGB);
	if(FAILED(hr)){
		MessageBox(g_hDlg,"2",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	// gptB^Otw
	if(FAILED(g_pCGB->SetFiltergraph(g_pGB))){
		MessageBox(g_hDlg,"3",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	// \[XtB^擾ătB^Otɒǉ
	WCHAR	wLoadName[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,g_loadname,-1,wLoadName,sizeof(wLoadName));
	RELEASE(g_pSrc);
	if(FAILED(g_pGB->AddSourceFilter(wLoadName, L"Source Filter", &g_pSrc))){
		MessageBox(g_hDlg,"4",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	// I[fBI GR[_̒ǉ
	if(g_de[0].pFil[g_de[0].order[g_de[0].idx]]){
		if(FAILED(g_pGB->AddFilter(g_de[0].pFil[g_de[0].order[g_de[0].idx]], L"Audio Decoder"))){
			MessageBox(g_hDlg,"7",MYWNDTITLE,MB_OK);
			return FALSE;
		}
	}
	if(g_bAvi == 0){		// I[fBI t@Cɕۑꍇ
		if (!Save_WavFile()){
			return FALSE;
		}
	}
	else{				// AVI t@Cɕۑꍇ
		if (!Save_AviFile()){
			return FALSE;
		}
	}
	// Cxg擾邽߂̐ݒ
	RELEASE(g_pME);
	if(FAILED(g_pGB->QueryInterface(IID_IMediaEventEx, (void**)&g_pME))){
		MessageBox(0,"5",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	g_pME->SetNotifyWindow((OAHWND)g_hDlg, WM_GRAPHNOTIFY, 0);
	// Ro[gJnEI삷邽߂̐ݒ	
	RELEASE(g_pMC);
	if(FAILED(g_pGB->QueryInterface(IID_IMediaControl, (void**)&g_pMC))){
		MessageBox(g_hDlg,"6",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	// Ro[gJn
	if(g_pMC){
		g_pMC->Run();
		SetCapture(g_hDlg);
		SetCursor(LoadCursor(NULL,IDC_WAIT));
		Set_Title("ϊEEE ");
	}
	return TRUE;
}// Run_Graph

// WAVt@Cɕۑ
//@DXSDK\Samples\C++\DirectShow\BaseClassesrhA
//@DXSDK\Samples\C++\DirectShow\Filters\WavDestrh
//@wavdest.ax 쐬B
//	炩߁Awavdest.ax  C:\\Windows\\System ɃRs[A
//	[X^[g][t@Cw肵Ďs]ŁA
//	Regsvr32 wavdest.ax Ɠ͂[OK]NbNKvB
bool Save_WavFile()
{
	static const GUID CLSID_WavDest =
	{ 0x3c78b8e2, 0x6c4d, 0x11d1, { 0xad, 0xe2, 0x0, 0x0, 0xf8, 0x75, 0x4b, 0x99 } };
	HRESULT 	hr;
	IBaseFilter	*pMux = NULL;
	hr = CoCreateInstance(CLSID_WavDest, NULL, CLSCTX_INPROC_SERVER, 
						  IID_IBaseFilter, (void **)&pMux);
	if(FAILED(hr)){
		MessageBox(g_hDlg,"8",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	if(FAILED(g_pGB->AddFilter(pMux, L"WavDest"))){
		RELEASE(pMux);
		MessageBox(g_hDlg,"9",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	IFileSinkFilter2	*pFS = NULL;
	hr = CoCreateInstance(CLSID_FileWriter, NULL, CLSCTX_INPROC_SERVER,
						  IID_IFileSinkFilter2, (void **)&pFS);
	if(FAILED(hr)){
		RELEASE(pMux);
		MessageBox(g_hDlg,"10",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	pFS->SetMode(AM_FILE_OVERWRITE);
	IBaseFilter		*pFW = NULL;
	if(FAILED(pFS->QueryInterface(IID_IBaseFilter, (void **)&pFW))){
		RELEASE(pFS);
		RELEASE(pMux);
		MessageBox(g_hDlg,"11",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	if(FAILED(g_pGB->AddFilter((IBaseFilter *)pFW, L"FileWriter"))){
		RELEASE(pFS);
		RELEASE(pMux);
		MessageBox(g_hDlg,"12",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	WCHAR	wSaveName[MAX_PATH];
	MultiByteToWideChar(CP_ACP,0,g_savename,-1,wSaveName,sizeof(wSaveName));
	if(FAILED(pFS->SetFileName(wSaveName, NULL))){
		RELEASE(pFW);
		RELEASE(pFS);
		RELEASE(pMux);
		MessageBox(g_hDlg,"13",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	// \[XtB^Audio DecoderWavDestڑ
	hr = g_pCGB->RenderStream(NULL, NULL, g_pSrc, g_de[0].pFil[g_de[0].order[g_de[0].idx]], pMux);
	if(FAILED(hr)){
		RELEASE(pFW);
		RELEASE(pFS);
		RELEASE(pMux);
		MessageBox(g_hDlg,"14",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	// WavDestt@CC^ڑ
	hr = g_pCGB->RenderStream(NULL, NULL, pMux, NULL, pFW);
	if(FAILED(hr)){
		RELEASE(pFW);
		RELEASE(pFS);
		RELEASE(pMux);
		MessageBox(g_hDlg,"15",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	RELEASE(pFW);
	RELEASE(pFS);
	RELEASE(pMux);
	return TRUE;
}// Save_WavFile

// AVIt@Cɕۑ
bool Save_AviFile()
{
	HRESULT		hr;
	WCHAR		wSaveName[MAX_PATH];
	
	if(g_de[1].pFil[g_de[1].order[g_de[1].idx]]){
		// rfIRvbT̒ǉ
		if(FAILED(g_pGB->AddFilter(g_de[1].pFil[g_de[1].order[g_de[1].idx]], L"Video Compressor"))){
			MessageBox(g_hDlg,"16",MYWNDTITLE,MB_OK);
			return FALSE;
		}
		// k̕ύX
		IAMVideoCompression *pVC = NULL;
		hr = g_pCGB->FindInterface(&LOOK_DOWNSTREAM_ONLY, NULL, g_de[1].pFil[g_de[1].order[g_de[1].idx]], IID_IAMVideoCompression, (void**)&pVC);
		if(SUCCEEDED(hr)){
			int		sz1 = 0,sz2 = 0;// ̑傫
			long	lCap;			// \̓tO
			double	QualityDef;		// ftHg̕il
			
			if(SUCCEEDED(pVC->GetInfo(0, &sz1, 0, &sz2, 0, 0, &QualityDef, &lCap))){
				if(lCap & CompressionCaps_CanQuality){
					g_quality = SendMessage(g_hSldr, TBM_GETPOS, 0, 0);
					pVC->put_Quality((float)g_quality / 100);	// íA0.0(Œ) ` 1.0(ō)
				}
			}
			RELEASE(pVC);
		}
	}
	if(GetFileAttributes(g_savename) != -1){
		remove(g_savename);
	}
	MultiByteToWideChar(CP_ACP,0,g_savename,-1,wSaveName,sizeof(wSaveName));
	IBaseFilter	*pMux = NULL;
	hr = g_pCGB->SetOutputFileName(&MEDIASUBTYPE_Avi, wSaveName, &pMux, NULL);
	if(FAILED(hr)){
		MessageBox(g_hDlg,"17",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	// \[XtB^HVideo CompressorAviMuxt@CC^ڑ
	// iAviMuxgpƁAt@CC^Iɒǉj
	hr = g_pCGB->RenderStream(NULL, NULL, g_pSrc, g_de[1].pFil[g_de[1].order[g_de[1].idx]], pMux);					// MPG
	if(FAILED(hr)){
		hr = g_pCGB->RenderStream(NULL, &MEDIATYPE_Video, g_pSrc, g_de[1].pFil[g_de[1].order[g_de[1].idx]], pMux);	// WMV
		if(FAILED(hr)){
			RELEASE(pMux);
			MessageBox(g_hDlg,"18",MYWNDTITLE,MB_OK);
			return FALSE;
		}
	}
	// \[XtB^HAudio EncoderAviMuxt@CC^ڑ
	hr = g_pCGB->RenderStream(NULL, NULL, g_pSrc, g_de[0].pFil[g_de[0].order[g_de[0].idx]], pMux);
	if(FAILED(hr)){
		RELEASE(pMux);
		MessageBox(g_hDlg,"19",MYWNDTITLE,MB_OK);
		return FALSE;
	}
	g_pCGB->RenderStream(NULL, NULL, g_pSrc, NULL, pMux);
	RELEASE(pMux);
	return TRUE;
}// Save_AviFile

// w肳ꂽJeS̃tB^񋓂
// hDlg   :[IN]  _CAÕnh
// clsid  :[IN]  GR[_ JeSCLSID
bool Enum_FiltersEnc(HWND hDlg, REFCLSID clsid)
{
	HRESULT			hr;
	ICreateDevEnum	*pEnum = NULL;
	IEnumMoniker	*pEm = NULL;
	IMoniker		*pM = NULL;
	ULONG			cFetched;
	int				idx;
	char			buf[MAX_LEN];
	
	if(clsid == CLSID_AudioCompressorCategory){
		idx = 0;
	}
	else{
		idx = 1;
	}
	
	hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER,
							IID_ICreateDevEnum, (void**)&pEnum);
	if(FAILED(hr)){
		return FALSE;
	}
	hr = pEnum->CreateClassEnumerator(clsid, &pEm, 0);
	if(FAILED(hr)){
		RELEASE(pEnum);
		return FALSE;
	}
	RELEASE(pEnum);
	
	for(int i=0;i<MAX_FIL;i++){
		RELEASE(g_de[idx].pFil[i]);
	}
	g_de[idx].pFil[0] = NULL;
	strcpy(g_de[idx].name[0], "none");
	g_de[idx].ct = 1;
	pEm->Reset();
	while(S_OK == pEm->Next(1, &pM, &cFetched))
	{
		IPropertyBag *pBag;
		hr = pM->BindToStorage(0, 0, IID_IPropertyBag, (void **)&pBag);
		if(SUCCEEDED(hr))
		{
			VARIANT var;
			var.vt = VT_BSTR;
			hr = pBag->Read(L"FriendlyName", &var, NULL);
			if(SUCCEEDED(hr))
			{
				WideCharToMultiByte(CP_ACP, 0, var.bstrVal, -1, buf, sizeof(buf), NULL, NULL);
				if(strcmp(buf, "")){
					if(SUCCEEDED(pM->BindToObject(NULL, NULL, IID_IBaseFilter, (void**)&g_de[idx].pFil[g_de[idx].ct]))){
						strncpy(g_de[idx].name[g_de[idx].ct], buf, MAX_LEN);
						g_de[idx].ct ++;
						if(g_de[idx].ct >= MAX_FIL){
							break;
						}
					}
				}
				SysFreeString(var.bstrVal);
			}
			RELEASE(pBag);
		}
		RELEASE(pM);
	}
	RELEASE(pEm);
	
	return TRUE;
}// Enum_FiltersEnc

//@ёւ
void Sort(int idx)
{
	int		h,i,ct;
	char	s[MAX_LEN];
	
	g_de[idx].order[0] = 0;
	SendMessage(g_hComb[idx], CB_ADDSTRING, 0, (LPARAM) g_de[idx].name[0]);
	strcpy(s, "");
	ct = 1;
	while(strcmp(s, "~~")){
		strcpy(s, "~~");
		h = -1;
		for(i=1;i<g_de[idx].ct;i++){
			if(_mbsicmp((LPBYTE)g_de[idx].name[i], (LPBYTE)s) < 0){
				strcpy(s, g_de[idx].name[i]);
				h = i;
			}
		}
		if(h != -1){
			SendMessage(g_hComb[idx], CB_ADDSTRING, 0, (LPARAM) g_de[idx].name[h]);
			g_de[idx].order[ct] = h;
			if(idx > 0 && !strncmp(g_de[idx].name[h], "Indeo", 5)){
				g_de[idx].idx = ct;
			}
			if(idx == 0 && !strcmp(g_de[0].name[h], "PCM")){
				g_PCM = ct;
			}
			strcpy(g_de[idx].name[h], "~~");
			ct ++;
		}
	}
}// Sort

void Enable_AVI(bool bEnable)
{
	EnableWindow(g_hSttc[0], bEnable);
	EnableWindow(g_hSldr,    bEnable);
	EnableWindow(g_hSttc[2], bEnable);
	EnableWindow(g_hComb[1], bEnable);
}// Enable_AVI

// ^Cgݒ
// addStr:  [IN] ǉ̕
void Set_Title(char *addStr)
{
	char *p,title[256];
	p = strrchr(g_loadname, '\\');
	_snprintf(title,sizeof(title),"%s%s  <%s>",addStr,p+1,MYWNDTITLE);
	SendMessage(g_hDlg, WM_SETTEXT, 0, (LPARAM) title);
}// Set_Title

// I[vt@C_CAO
bool Open_FileDlg()
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH] = "";
	
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = g_hDlg;
	ofn.Flags = OFN_PATHMUSTEXIST | 
				OFN_FILEMUSTEXIST | 
				OFN_HIDEREADONLY; 
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	//tB^w肷ƂB
	ofn.lpstrFilter =	"ި̧ (avi wmv wav wma asf mp3 mpg)\0" "*.wav;*.avi;*.wma;*.wmv;*.asf;*.mp3;*.mpg\0" 
						"̧ (*.*)\0" "*.*\0";
	ofn.nFilterIndex = 1;
	if(GetOpenFileName(&ofn)){
		strcpy(g_loadname, fn);
		return TRUE;
	}
	return FALSE;
}// Open_FileDlg

// ۑt@C_CAO
void Save_FileDlg()
{
	OPENFILENAME	ofn;
	char			fn[MAX_PATH] = "";
	
	ZeroMemory(&ofn, sizeof(ofn));
	ofn.lStructSize = sizeof(ofn);
	ofn.hwndOwner = g_hDlg;
	ofn.Flags = OFN_OVERWRITEPROMPT;
	ofn.lpstrFile = fn;
	ofn.nMaxFile = sizeof(fn);
	Set_SaveType();
	switch (g_ext_idx)
	{
	case 0:
		ofn.lpstrFilter = "޳ ި ̧ (*.wma)\0*.wma\0"
						  "̧ (*.*)\0*.*\0\0";
		break;
	case 1:
		ofn.lpstrFilter = "MPEG Layer-3 ̧ (*.mp3)\0*.mp3\0"
						  "̧ (*.*)\0*.*\0\0";
		break;
	case 2:
		ofn.lpstrFilter = "̧ (*.wav)\0*.wav\0"
						  "̧ (*.*)\0*.*\0\0";
		break;
	case 3:
		ofn.lpstrFilter = "AVI̧ (*.avi)\0*.avi\0"
						  "̧ (*.*)\0*.*\0\0";
		break;
	default:
		ofn.lpstrFilter = "̧ (*.*)\0*.*\0\0";
		break;
	}
	ofn.nFilterIndex = 1;
	if(GetSaveFileName(&ofn)){
		strncpy(g_savename, fn, sizeof(g_savename));
		if(!stricmp(g_savename, g_loadname)){
			MessageBox(g_hDlg,"ǂݍ݃t@Cɂ͕ۑł܂",MYWNDTITLE,MB_OK);
		}
		else{
			if(!strrchr(g_savename, '.')){
				strcat(g_savename, g_ext_s[g_ext_idx]);
			}
			if(!Run_Graph()){
				Cleanup();
				MessageBox(g_hDlg,"ۑł܂",MYWNDTITLE,MB_OK);
			}
		}
	}
}// Save_FileDlg

void Set_SaveType()
{
	if(!g_bAvi){
		char name[MAX_LEN];
		SendMessage(g_hComb[0], WM_GETTEXT, sizeof(name), (LPARAM)name);
		if(!strcmp(name, "WMAudio Encoder DMO")){
			g_ext_idx = 0;
		}
		else if(!strcmp(name, "MPEG Layer-3")){
			g_ext_idx = 1;
		}
		else if(!strcmp(name, "PCM")){
			g_ext_idx = 2;
		}
		else{
			g_ext_idx = 4;
		}
	}
	else{
		g_ext_idx = 3;
	}
}// Set_SaveType

// IuWFNg̉
void Cleanup()
{
	if(g_pMC){
		g_pMC->Stop();
	}
	if(g_pME){
		g_pME->SetNotifyWindow(NULL, 0, 0);
	}
	EnableWindow(g_hBttn, TRUE);
	RELEASE(g_pSrc);
	RELEASE(g_pME);
	RELEASE(g_pMC);
	RELEASE(g_pGB);
	RELEASE(g_pCGB);
}// Cleanup
